/*
 * Created on 10.04.2003
 *
 */
 
//import java.util.*;
/**
 * @author khb
 *
 * Generiert Primzahlen nach dem Sieb des Eratosthenes
 */
public class PrimeGenerator
{
	public static int[] generatePrimes(int maxValue)
	{
		if(maxValue < 2)
			return new int[0];
		else
		{
			initializeArrayOfBooleans(maxValue);
			crossOutMultiples();
			loadPrimes();
			return primes;
		}
		
	}
	private static void loadPrimes()
	{
		primes = new int[numberOfUncrossedIntegers()];
		for (int j=0,i=2;i<isCrossed.length;i++)
		{
			if (notCrossed(i))
			{
				primes[j++] = i;
			}
				
		}
	}
	private static void crossOutMultiples()
	{
		int maxPrimeFactor =calcMaxPrimeFactor();
		for (int i = 2;i <= maxPrimeFactor;i++)
			if(notCrossed(i))
			{
				crossOutMultiplesOf(i);
			}
	}
	private static void crossOutMultiplesOf(int i)
	{
		for (int multiple = 2*i;multiple < isCrossed.length;multiple += i)
			isCrossed[multiple] = true;
	}
	private static int numberOfUncrossedIntegers()
	{
		int count = 0;
		for (int i = 2; i < isCrossed.length;i++)
		if(notCrossed(i))	
			count++;
		return count;

	}
	private static boolean notCrossed(int i)
	{
		return (isCrossed[i] == false);
	}
	private static int calcMaxPrimeFactor()
	{
		double maxPrimFactor = Math.sqrt(isCrossed.length+1);
		return (int) maxPrimFactor;
	}
	private static void initializeArrayOfBooleans(int maxValue)
	{
		isCrossed = new boolean[maxValue+1];
		for(int i = 0; i < isCrossed.length;i++)
		isCrossed[i] = false;
	}
	private static boolean[] isCrossed;
	private static int[] primes;
}
